clear all

rng(1); % For reproducibility

Nt1=50;  % N?mero de padr?es de treinamento
Nt2=100;  % N?mero de padr?es de treinamento
Nv=40;   % N?mero de vetores de c?digo
offs=0; % offset em x e y (para n?o ficar centrado na origem)

r = sqrt(rand(Nt1,1)); % Radius
t = 2*pi*rand(Nt1,1);  % Angle
data1 = [r.*cos(t)+offs, r.*sin(t)+offs]; % Points

r2 = sqrt(3*rand(Nt2,1)+1); % Radius
t2 = 2*pi*rand(Nt2,1);      % Angle
data2 = [r2.*cos(t2)+offs, r2.*sin(t2)+offs]; % points


%target=[ones(1,Nt1) 2*ones(1,Nt2)];
target=[ones(1,Nt1) zeros(1,Nt2)
        zeros(1,Nt1) ones(1,Nt2)];
data=[data1' data2'];

%T=ind2vec(target);
%netl=patternnet(20)
netl=lvqnet(Nv);
netl.trainParam.epochs=150;
%netl=train(netl,data,T);
netl=train(netl,data,target);

netl.LW{2,1}    % classes
figure(1),hold off; 
plot(data1(:,1),data1(:,2),'ro','MarkerSize',10), hold on,
plot(data2(:,1),data2(:,2),'b+','MarkerSize',10)

for i=1:Nv,
 if netl.LW{2,1}(1,i)==1,
  plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'r*','MarkerSize',12)
 end
 if netl.LW{2,1}(2,i)==1,
  plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'b*','MarkerSize',12)
 end
end

ezpolar(@(x)1);ezpolar(@(x)2);

legend('train A','train B','vet. codigo A','vet. codigo B')
axis([-2.5 2.5 -2.5 2.5]+offs)
xlabel('x_1'),ylabel('x_2')

axis equal


for x=-2.5:.2:2.5 +offs,
    for y=-2.5:.2:2.5 +offs,
        Res=netl([x;y]);
        class=vec2ind(Res);
        if class==1 plot(x,y,'k.')
        else plot(x,y,'cx')
        end
    end
    drawnow
end

return

figure(2);hold off
plot(netl.IW{1}(1:Nv1,1),netl.IW{1}(1:Nv1,2),'r*','MarkerSize',12)
hold on;
plot(netl.IW{1}(Nv1+1:Nv1+Nv2,1),netl.IW{1}(Nv1+1:Nv1+Nv2,2),'b*','MarkerSize',12)
ezpolar(@(x)1);ezpolar(@(x)2);
legend('vet. codigo A','vet. codigo B')
axis([-2.5 2.5 -2.5 2.5]+offs)
xlabel('x_1'),ylabel('x_2')
axis equal




return

figure;
target=[ones(1,100) zeros(1,100)];
data=[data1' data2'];

net=newff(data,target,30);
net=train(net,data,target)


for x=-2.5:.1:2.5,
    for y=-2.5:.1:2.5,
        if net([x;y])>0.5 plot(x,y,'k.')
        else plot(x,y,'cx')
        end
    end
    drawnow
end