clear all

rng(.1); % For reproducibility

Nt1=80;  % N?mero de padr?es de treinamento
Nt2=80;  % N?mero de padr?es de treinamento
Nt3=80;  % N?mero de padr?es de treinamento
Nv=15;   % N?mero de vetores de c?digo
offs=0; % offset em x e y (para n?o ficar centrado na origem)

r = rand(Nt1,1); % Radius
t = 2*pi*rand(Nt1,1);  % Angle
data1 = [r.*cos(t)+offs, r.*sin(t)+offs]; % Points

r2 = rand(Nt2,1)+1; % Radius
t2 = 2*pi*rand(Nt2,1);      % Angle
data2 = [r2.*cos(t2)+offs, r2.*sin(t2)+offs]; % points

r3 = rand(Nt3,1)+2; % Radius
t3 = 2*pi*rand(Nt3,1);      % Angle
data3 = [r3.*cos(t3)+offs, r3.*sin(t3)+offs]; % points


%target=[ones(1,Nt1) 2*ones(1,Nt2)];
target=[ones(1,Nt1) zeros(1,Nt2) zeros(1,Nt3)
        zeros(1,Nt1) ones(1,Nt2) zeros(1,Nt3)
        zeros(1,Nt1) zeros(1,Nt2) ones(1,Nt3)];
data=[data1' data2' data3'];

%T=ind2vec(target);
%netl=patternnet(20)
netl=lvqnet(Nv,0.1,'learnlv1');



netl.trainParam.epochs=1;
netl=train(netl,data,target);    % cria vetores iniciais (no centro da distribui??o)
netl.IW{1}= 0.4*randn(size(netl.IW{1}))  % espalha os vetores pelo dom?nio (evitar neur?nios mortos)

netl.LW{2,1}    % mostra as classes

figure(1),hold off; 
ezpolar(@(x)3);hold on;ezpolar(@(x)2);ezpolar(@(x)1);
plot(data1(:,1),data1(:,2),'k.','MarkerSize',10)
plot(data2(:,1),data2(:,2),'bx','MarkerSize',10)
plot(data3(:,1),data3(:,2),'r*','MarkerSize',10)
legend('train A','train B','train C')

% %%%%%%%%%%%%%%%%%%%%%%%%%% final result
% title('Initial LVQ - Weihgths')
% axis equal
j=10;

   for i=1:Nv,
       if netl.LW{2,1}(1,i)==1,
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'k.','MarkerSize',j),
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'ko','MarkerSize',j),
       end
       if netl.LW{2,1}(2,i)==1,
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'bx','MarkerSize',j),
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'ko','MarkerSize',j),
        end
       if netl.LW{2,1}(3,i)==1,
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'r*','MarkerSize',j),
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'ko','MarkerSize',j),
       end
   end
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%return

figure(2), hold off
ezpolar(@(x)3);hold on; ezpolar(@(x)2);ezpolar(@(x)1);
legend('vect A','vect B','vect C')
axis([-4 4 -4 4]+offs)
xlabel('x_1'),ylabel('x_2')

figure(2); hold on
netl.trainParam.epochs=150; %10
j=10;
for mn=1:1, %10
   netl=train(netl,data,target);
    
   for i=1:Nv,
       if netl.LW{2,1}(1,i)==1,
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'k.','MarkerSize',j),
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'ko','MarkerSize',j),
       end
       if netl.LW{2,1}(2,i)==1,
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'bx','MarkerSize',j),
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'bo','MarkerSize',j),
       end
       if netl.LW{2,1}(3,i)==1,
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'r*','MarkerSize',j),
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'ro','MarkerSize',j),
       end
       drawnow
   end
end

%%%%%%%%%%%%%%%%%%%%%%%%%% final result
figure(3), hold off 
ezpolar(@(x)3);hold on; ezpolar(@(x)2);ezpolar(@(x)1);
%legend('vect A','vect B','vect C'), 
title('LVQ - Validacao e Vetores')
axis equal

j=12;
   for i=1:Nv,
       if netl.LW{2,1}(1,i)==1,
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'k.','MarkerSize',j),
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'ko','MarkerSize',j),
       end
       if netl.LW{2,1}(2,i)==1,
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'bx','MarkerSize',j),
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'ko','MarkerSize',j),
       end
       if netl.LW{2,1}(3,i)==1,
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'r*','MarkerSize',j),
           plot(netl.IW{1}(i,1),netl.IW{1}(i,2),'ko','MarkerSize',j),
       end
   end
   

for x=-3:.2:3 +offs,
    for y=-3:.2:3 +offs,
        Res=netl([x;y]);
        class=vec2ind(Res);
        if class==1, plot(x,y,'k.'), end
        if class==2, plot(x,y,'bx'), end
        if class==3, plot(x,y,'r*'), end
     
    end
    drawnow
end

return

figure(2);hold off
plot(netl.IW{1}(1:Nv1,1),netl.IW{1}(1:Nv1,2),'r*','MarkerSize',12)
hold on;
plot(netl.IW{1}(Nv1+1:Nv1+Nv2,1),netl.IW{1}(Nv1+1:Nv1+Nv2,2),'b*','MarkerSize',12)
ezpolar(@(x)1);ezpolar(@(x)2);ezpolar(@(x)3);
legend('vet. codigo A','vet. codigo B')
axis([-2.5 2.5 -2.5 2.5]+offs)
xlabel('x_1'),ylabel('x_2')
axis equal




return

figure;
target=[ones(1,100) zeros(1,100)];
data=[data1' data2'];

net=newff(data,target,30);
net=train(net,data,target)


for x=-2.5:.1:2.5,
    for y=-2.5:.1:2.5,
        if net([x;y])>0.5 plot(x,y,'k.')
        else plot(x,y,'cx')
        end
    end
    drawnow
end